#ifndef fooversionhfoo /*-*-C-*-*/
#define fooversionhfoo

/* $Id: version.h.in 621 2006-03-02 21:56:15Z ossman $ */

/***
  This file is part of polypaudio.
 
  polypaudio is free software; you can redistribute it and/or modify
  it under the terms of the GNU Lesser General Public License as published
  by the Free Software Foundation; either version 2 of the License,
  or (at your option) any later version.
 
  polypaudio is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  General Public License for more details.
 
  You should have received a copy of the GNU Lesser General Public License
  along with polypaudio; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
  USA.
***/

/* WARNING: Make sure to edit the real source file version.h.in! */

#include <polyp/cdecl.h>

/** \file
 * Define header version */

PA_C_DECL_BEGIN

/** Return the version of the header files. Keep in mind that this is
a macro and not a function, so it is impossible to get the pointer of
it. */
#define pa_get_headers_version() ("0.8.1")

/** Return the version of the library the current application is linked to. */
const char* pa_get_library_version(void);

/** The current API version. Version 6 relates to polypaudio
 * 0.6. Prior versions (i.e. Polypaudio 0.5.1 and older) have
 * PA_API_VERSION undefined.  */
#define PA_API_VERSION 8

/** The current protocol version. Version 8 relates to polypaudio 0.8.
 * \since 0.8 */
#define PA_PROTOCOL_VERSION 8

PA_C_DECL_END

#endif
